<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Warehouse_Model extends CI_Model {
  
  private $tableName = 'warehouses';
  
  function __construct() 
  {
    /* Call the Model constructor */
    parent::__construct();
  }

	function save_warehouse(&$warehouse_data,$warehouse_id=false)
	{
		if (!$warehouse_id)
		{
			$this->db->insert($this->tableName,$warehouse_data);
		}else {
			$this->db->where('id', $warehouse_id);
			return $this->db->update($this->tableName,$warehouse_data);
			
		}
		
	}	
	
	function get_all_warehouse() {
		$this->db->select($this->tableName.'.*');
		$this->db->order_by("id", "desc");
		$this->db->where("id IS NOT NULL");//("id !=",$id);
		$query = $this->db->get($this->tableName);
		return $query->result();
	}
	
	public function get_warehouse_info($id)
	 {
		$this->db->select('*');
		$this->db->from($this->tableName);
		$this->db->where("id", $id);
		$this->db->order_by("id", "desc");
		$query = $this->db->get();
		return $query->row_array(); 
	 }
	
	public function delete_warehouse($warehouse_id)
	{
		$this->db->where('id', $warehouse_id);
		$this->db->delete($this->tableName);
	
	}

	public function disable_warehouse($warehouse_id)
	{
		$data = array(
			'status' => 0
		);	
		$this->db->where('id', $warehouse_id);
		$this->db->update($this->tableName, $data);
	}
	
	public function enable_warehouse($warehouse_id)
	{
		$data = array(
			'status' => 1
		);	
		$this->db->where('id', $warehouse_id);
		$this->db->update($this->tableName, $data);
		
	}
	
		function user_assigned_warehouses($uaw_data,$user_id)
	{
		if ($user_id)
		{
			$this->db->insert('user_assigned_warehouses',$uaw_data);
		}	
		
	}		

	public function delete_user_assigned_warehouses($user_id)
	{
		$this->db->where('uaw_user_id', $user_id);
		$this->db->delete('user_assigned_warehouses');
	
	}
	
	public function check_is_user_assigned_to_warehouses_del($user_id, $warehouse_id)
	 {
		$this->db->select('uaw_user_id');
		$this->db->from('user_assigned_warehouses');
		$this->db->where("uaw_user_id", $user_id);
		$this->db->where("uaw_warehouse_id", $warehouse_id);
		$query = $this->db->get();
		//print_r($query);
		//echo $this->db->last_query();
		//return $query->num_rows();//count($query->row_array());
		//if($query->num_rows()>0 )
		  {
			//$row =  $query->row();
			//print_r($row);
			// return count($row); // return the count
			// return 1;
		  }
		  return $query->num_rows();
		// return $query->row_array(); 
		  
	 }
}