<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Booking extends CI_Controller {

    var $main_menu_name = "booking";
	var $sub_menu_name = "list_booking";

	public function __construct()
	{
		parent::__construct();

		$this->load->model('Booking_Model');
		$this->load->model('Warehouse_Model');
		$this->load->model('Common_Model');
		$this->load->model('Customer_Model');
		$this->load->model('Menu_Model');
		$this->load->model('User_Model');
		$this->load->model('System_Settings_Model');
		$this->load->model('Unit_Model');
		$this->load->model('Menu_Items_List_Model');
	}
	
	//Sales list page load
	public function index()
	{
		 
		//$data['sales'] = $this->Sales_Model->get_all_sales();
		$data['main_menu_name'] = $this->main_menu_name;
		$data['sub_menu_name'] = $this->sub_menu_name;
		$warehouse_list=$this->Warehouse_Model->get_all_warehouse();
		$data['warehouse_list'] = $warehouse_list;
        $this->load->view('booking',$data);
	}	
	
	public function change_collected_status(){
		//echo 'test';
		$paymnt_id=$this->input->post('paymnt_id');
		$pymnt_collected=$this->input->post('pymnt_collected');
		$data=array(
				'paymnt_id'=>$paymnt_id,	
				'pymnt_collected'=>$pymnt_collected
		);                                                                                
		
		if ($this->Booking_Model->change_collected_status($data,$paymnt_id)) {
                    $st = array('status' =>1,'validation' =>'Done!');
                    echo json_encode($st);
         }       
		 //echo $this->db->last_query();                                                  
		 $st = array('status' =>0);
         echo json_encode($st);
		
	}
	


	public function add_payments()
	
	{
		$pymnt_amount=$this->input->post('pymnt_amount');
		$bkng_id=$this->input->post('bkng_id');
		
		$pymnt_paying_by=$this->input->post('pymnt_paying_by');
		$pymnt_date_time=$this->input->post('pymnt_date_time');
		$pymnt_date_time_send=date('Y-m-d H:i:s', strtotime($pymnt_date_time));
		$pymnt_cheque_no=$this->input->post('pymnt_cheque_no');
		$pymnt_crdt_card_no=$this->input->post('pymnt_crdt_card_no');
		$pymnt_crdt_card_holder_name=$this->input->post('pymnt_crdt_card_holder_name');
		$pymnt_crdt_card_month=$this->input->post('pymnt_crdt_card_month');
		$pymnt_crdt_card_year=$this->input->post('pymnt_crdt_card_year');
		$pymnt_crdt_card_type=$this->input->post('pymnt_crdt_card_type');
		
		$pymnt_given_amount=$this->input->post('pymnt_given_amount');
		$pymnt_balance_amount=$this->input->post('pymnt_balance_amount');
		
		

		$pymnt_note=$this->input->post('pymnt_note');
		$user_id=$this->session->userdata('ss_user_id');
		$pymnt_added_date_time=date("Y-m-d H:i:s");
		$pymnt_id='';
		$pymnt_ref_no=$this->Common_Model->gen_ref_number('paymnt_id','booking_payment','REF/');;
		
        $this->load->library('form_validation'); //form validation lib
        $this->form_validation->set_rules('pymnt_amount', 'Amount', 'required');
		if($pymnt_paying_by=='Credit Card'){
			$this->form_validation->set_rules('pymnt_crdt_card_type', 'Card Type', 'required');
			$this->form_validation->set_rules('pymnt_crdt_card_no', 'Credit Card No', 'required');
			$this->form_validation->set_rules('pymnt_crdt_card_holder_name', 'Holder Name', 'required');
			$this->form_validation->set_rules('pymnt_crdt_card_month', 'Month', 'required');
			$this->form_validation->set_rules('pymnt_crdt_card_year', 'Year', 'required');
		}
		if($pymnt_paying_by=='Cheque'){
			$this->form_validation->set_rules('pymnt_cheque_no', 'Cheque No', 'required');
		}
		$this->form_validation->set_rules('bkng_id', 'System Error', 'required');


        if ($this->form_validation->run() == FALSE)
        {
           $st = array('status' =>0,'validation' => validation_errors());
           echo json_encode($st);
        }
        else
        {
			$data=array(
				'pymnt_amount'=>$pymnt_amount,	
				'pymnt_ref_no'=>$pymnt_ref_no,
				'pymnt_paying_by'=>$pymnt_paying_by,
				'pymnt_date_time'=>$pymnt_date_time_send,
				'pymnt_note'=>$pymnt_note,
				'user_id'=>$user_id,
				'bkng_id'=>$bkng_id,
				'pymnt_added_date_time'=>$pymnt_added_date_time,
				'pymnt_cheque_no'=>$pymnt_cheque_no,
				'pymnt_crdt_card_no'=>$pymnt_crdt_card_no,
				'pymnt_crdt_card_holder_name'=>$pymnt_crdt_card_holder_name,
				'pymnt_crdt_card_type'=>$pymnt_crdt_card_type,
				'pymnt_crdt_card_month'=>$pymnt_crdt_card_month,
				'pymnt_crdt_card_year'=>$pymnt_crdt_card_year,
				//'sale_payment_type' => $sale_type,
				'pymnt_given_amount' => $pymnt_given_amount,
				'pymnt_balance_amount' => $pymnt_balance_amount
			);
			
               if ($this->Booking_Model->save_booking_payments($data)) {
                    $st = array('status' =>1,'validation' =>'Done!');
                    echo json_encode($st);
               } else {
                    $st = array('status' =>0,'validation' =>'error occurred please contact your system administrator');
                    echo json_encode($st);
               }
		}
	}	

		
	//booking calendar
    public function booking_calendar()
    {
        
        //echo "1111 , ";
		$data['main_menu_name'] = $this->main_menu_name;
		//$data['sub_menu_name'] = 'booking_calendar';
		$warehouse_id=$this->uri->segment('3');
		$data['booking_details']=$this->Booking_Model->getBookingsCal($warehouse_id);
		if($warehouse_id==1){
			$data['sub_menu_name'] = 'booking_calendar_1';
		}
		if($warehouse_id==2){
			$data['sub_menu_name'] = 'booking_calendar_2';
		}
		if($warehouse_id==3){
			$data['sub_menu_name'] = 'booking_calendar_3';
		}
		if($warehouse_id==0){
			$data['sub_menu_name'] = 'booking_calendar_all';
		}
		$ss_warehouse_id=$this->session->userdata('ss_warehouse_id');
		//echo $this->db->last_query();
	//	if($warehouse_id)
		{
			$data['booking_details']=$this->Booking_Model->getBookingsCal($warehouse_id);
			$data['warehouse_details']=$this->Warehouse_Model->get_warehouse_info($warehouse_id);
			$data['system_settings']=$this->System_Settings_Model->get_system_settings_info(1);
			
			/*
			//check correct wharehouse
			if($this->session->userdata('ss_group_id')==2){
			$this->load->view('booking_calendar',$data);
			}else if($this->session->userdata('ss_group_id')==3 || $this->session->userdata('ss_group_id')==4){
				if($ss_warehouse_id==$warehouse_id){
					$this->load->view('booking_calendar',$data);
				}
				else {
					// no accdess
					redirect(base_url()); 
				}
			}
			*/
			
		//	echo "2222 , ";
		
			 $this->load->view('booking_calendar',$data);
			
			/*
			 if(check_is_avalable_warehouse_by_user_id($warehouse_id)){
				 $this->load->view('booking_calendar',$data);
			 }else{
				 redirect(base_url()); 
			 }
			 */
			 
		//	 echo "3333 , ";
		}
    }
	
		
	
	//booking calendar
    public function get_booking_details_by_id_for_booking_calendar()
    {
		$bkng_id=$this->input->post('bkng_id');
		$d = $this->Booking_Model->get_booking_details_by_id($bkng_id);
		//print_r($d);
		$bkng_refno=$d->bkng_refno;
		
		if ($d) {
			$cus_name=$d->cus_name;
			$detailsurl=base_url('booking/details/')."/".$bkng_id;
			$bkng_refno=$bkng_refno;
			$menu_name=$d->menu_name;
			$bkng_tot_amount=$d->bkng_tot_amount;
			$bkng_tot_amount_dis=number_format(($bkng_tot_amount), 2, '.', ',');
			$paid_amount=$this->Booking_Model->get_total_paid_by_booking_id($bkng_id);
			$paid_amount_dis=number_format(($paid_amount), 2, '.', ',');
			$balance=$bkng_tot_amount-$paid_amount;
			$balance_dis=number_format(($balance), 2, '.', ',');
			$bkng_details="<div class='pull-right'><a href='".$detailsurl."' target='_blank'>More Details</a> <i aria-hidden='true' class='fa fa-mail-forward'></i></div>
			<table width='100%' border='0'>
			<tr><td>Booking ID: </td><td>".$bkng_refno."</td></tr>
			<tr><td>Menu Name:</td><td>$menu_name</td></tr><tr><td>Customer Name: </td><td>$cus_name</td></tr>
			<tr><td>Total Amount: </td><td>$bkng_tot_amount_dis</td></tr>
			<tr><td>Total Paid: </td><td>$paid_amount_dis</td></tr>
			<tr><td>Balance: </td><td>$balance_dis</td></tr>
			</table><div class='input-group'><span class='input-group-btn'></span></div>";
		  $e = array('status' =>1,'bkng_id' =>$bkng_id,'bkng_refno' =>$bkng_refno,'bkng_details' =>$bkng_details);
		  echo json_encode($e);
		} else {
		  $e = array('status' =>0);
		  echo json_encode($e);
		}
    }
	
 public function menu_item_suggestions($value='')
    {
		$term=$this->input->get('term');
		$warehouse_id=$this->input->get('w');
		$data['items'] = $this->Booking_Model->get_menu_items_suggestions($term);
		//print_r($data['items']);
		$json = array();
		foreach ($data['items'] as $row)
		{
			$item_code=$row['item_code'];
			$item_name=$row['item_name'];
			if($warehouse_id==3){
				$item_price=$row['item_price_1'];
			}else{
				$item_price=$row['item_price_'.$warehouse_id];
			}
			$json_itm=array(
			 		'id'=> $row['item_id'],
					'item_id'=> $row['item_id'],
					'item_code'=> $row['item_code'],
					'item_name'=> $row['item_name'],
					'item_price'=> $item_price,
                    'value'=> $row['item_name']." (".$row['item_code'].")",
                    'label'=> $row['item_name']." (".$row['item_code'].")",
                    );
					array_push($json,$json_itm);
		}		
		echo json_encode($json);		
    }
	
	
 public function menu_extra_item_suggestions($value='')
    {
		$term=$this->input->get('term');
		$warehouse_id=$this->input->get('w');
		$data['items'] = $this->Booking_Model->get_menu_extra_items_suggestions($term);
		
		
		
		//print_r($data['items']);
		$json = array();
		foreach ($data['items'] as $row)
		{
			//get unit code by id
		
			$unit_dtls=$this->Unit_Model->get_unit_info($row['item_unit']);
			$unit_code=$unit_dtls['unit_code'];
		
			$item_code=$row['item_code'];
			$item_name=$row['item_name'];
			if($warehouse_id==3){
				$item_price=$row['item_price_1'];
			}else {
				$item_price=$row['item_price_'.$warehouse_id];
			}
			$json_itm=array(
			 		'id'=> $row['item_id'],
					'item_id'=> $row['item_id'],
					'item_id'=> $row['item_id'],
					'item_code'=> $row['item_code'],
					'item_name'=> $row['item_name'],
					'item_price'=> $item_price,
					'unit_code'=> $unit_code,
										
                    'value'=> $row['item_code']." ".$row['item_code']."",
                    'label'=> $row['item_name']." (".$row['item_name'].")",
                    );
					array_push($json,$json_itm);
		}		
		echo json_encode($json);		
    }	

    public function print_booking_invoice()
    {
		$data['main_menu_name'] = $this->main_menu_name;
		$data['sub_menu_name'] = 'booking_calendar';
		
		$bkng_id=$this->uri->segment('4');
		
		$data['bkng_id']=$bkng_id;
		//if($data['booking_all_details'][0])
		{
		$data['booking_all_details']=$this->Booking_Model->get_booking_detais_and_selected_all_menu_items($bkng_id);
		$data['booking_details']= $this->Booking_Model->get_booking_details_by_id($bkng_id);
		$data['user_details']=$this->User_Model->get_user_info($data['booking_all_details'][0]->bkng_user_id);	
		$data['booking_selected_menu_list'] = $this->Booking_Model->get_booking_selected_all_menu_items($bkng_id);
		$data['customer_details']= $this->Customer_Model->get_customer_info($data['booking_details']->cus_id);
		
		$data['booking_selected_extra_item_list'] = $this->Booking_Model->get_booking_selected_all_menu_items($bkng_id,'','extra_item');	
		$data['booking_payment_list']= $this->Booking_Model->get_booking_payments_by_booking_id($bkng_id);
        $this->load->view('models/print_booking_invoice',$data);
		}
    }
				
	//Sales details view
	public function booking_details()
	{
		$data['main_menu_name'] = $this->main_menu_name;
		$data['sub_menu_name'] = '';
		
		//get sale id
		$bkng_id=$this->uri->segment('3');
		//$data['sale_item_list']= $this->Sales_Model->get_sale_item_list_by_sale_id($sale_id);
		$data['booking_item_list']=array();
		$data['booking_details']= $this->Booking_Model->get_booking_details_by_id($bkng_id);
		
		$data['total_paid_amount']=$this->Booking_Model->get_total_paid_by_booking_id($bkng_id);

		$data['customer_details']= $this->Customer_Model->get_customer_info($data['booking_details']->cus_id);
		$data['warehouse_details']= $this->Warehouse_Model->get_warehouse_info($data['booking_details']->warehouse_id);
		$data['booking_selected_menu_list'] = $this->Booking_Model->get_booking_selected_all_menu_items($data['booking_details']->bkng_id);	
		
		$data['booking_selected_extra_item_list'] = $this->Booking_Model->get_booking_selected_all_menu_items($data['booking_details']->bkng_id,'','extra_item');	
		$data['booking_payment_list']= $this->Booking_Model->get_booking_payments_by_booking_id($bkng_id);
		$data['bkng_id']=$bkng_id;
        $this->load->view('booking_details',$data);
		
	}
	
	public function booking_payments()
	{
        $data['bkng_id'] =$this->uri->segment('3');
        
        $this->load->view('models/booking_payment',$data);	
	}


	//Add Booking
    public function booking_add()
    {
		$data['main_menu_name'] = $this->main_menu_name;
		$data['sub_menu_name'] = 'add_sales';
		
		//echo 'test:'.
		$bkng_id=$this->uri->segment('3');
		$data['warehouse_list'] = $this->Warehouse_Model->get_all_warehouse();
		$data['customer_list'] = $this->Customer_Model->get_all_customer();
		$data['menu_list'] = $this->Menu_Model->get_all_menu();
		//print_r($data['menu_list']);
		
		$data['bkng_id'] = $bkng_id;
		$data['type'] = 'add';
		
		$data['bkng_id']=$this->uri->segment('3');
		
		
		
		//get header data
		if($data['bkng_id']){
			
			$data['hdr_data']=$this->Booking_Model->get_booking_details_by_id($data['bkng_id']);
			
			//check booking editable
			$booking_editable=false;
			//echo "date:".$data['hdr_data']->bkng_date;
			$booking_editable=is_booking_editable($data['hdr_data']->bkng_date);
			
			
				$booking_editable=false;// for add old items
			
			if(!$booking_editable)
			{
			
			
			
			//print_r($data['hdr_data']);
			
			//get customer details
			$data['sel_customer_details']=$this->Customer_Model->get_customer_info($data['hdr_data']->cus_id);
			
			//get allredy selected menu items list
			//echo 'menu id:'.$data['hdr_data']->menu_id;
			$data['selected_menu_list'] = $this->Booking_Model->get_booking_selected_all_menu_items($bkng_id);
			//echo $this->db->last_query();
			$data['selected_extra_menu_list']=$this->Booking_Model->get_booking_selected_all_menu_items($bkng_id,'','extra_item');
			
			}
			else 
			{
				//no acsess
				redirect(base_url('dashboard'));	
			}
			//$this->Menu_Model->get_selected_all_menu_items($data['hdr_data']->menu_id);
			//print_r($data['vehicle_service_part_items_list']);
		}
		
		
        $this->load->view('booking_add',$data);
    }
	
	public function booking_menu_item_save()
	{
		
		$disMsg='';
		$error='';
		//print_r($this->input->post());
		//insert sale item data
			$row=$this->input->post('row_sr');
			$rowCount_sr=$this->input->post('rowCount_sr');
			$menu_id=$this->input->post('menu_id');
			$bkng_id=$this->input->post('bkng_id');
			$bkng_head_count=$this->input->post('bkng_head_count');
			$data_item=array();
			
			//delete old items
				$this->Booking_Model->delete_booking_assign_item($bkng_id);
				//echo $this->db->last_query();
			
			for($i=1; $i<=$rowCount_sr; $i++){
			//	echo "/ $rowCount , Test:".$row[$i]['product_id'][0];
			
			
				if(isset($row[$i]['item_id'][0]))
				{		
				$tot_amount=0;
				if($row[$i]['itm_type'][0]=='Extra'){
					$tot_amount=$row[$i]['price'][0]*$bkng_head_count;
				}			
				$data_item=array(
					'item_id'=>$row[$i]['item_id'][0],
					'bkng_id'=>$bkng_id,
					'bkng_itm_price'=>$row[$i]['price'][0],
					'bkng_itm_type'=>$row[$i]['itm_type'][0],
					'tot_amount'=>$tot_amount,
					'bkng_itm_added_date'=>date("Y-m-d H:i:s"),
					'user_id'=>$this->session->userdata('ss_user_id')
				);
				
				
				
				//add items
				$this->Booking_Model->save_menu_assign_item($data_item);
				//echo $this->db->last_query();
				
				}
				//save booking payment dtls
				$this->add_booking_dtls();
				//echo $this->db->last_query();
			}
			echo json_encode(array('error'=>$error,'disMsg'=>$disMsg,));
		
	}
	
	public function booking_extra_item_save()
	{
		
		$disMsg='';
		$error='';
		//print_r($this->input->post());
		//insert sale item data
			$row=$this->input->post('row_e');
			$rowCount_e=$this->input->post('rowCount_e');
			//$menu_id=$this->input->post('menu_id');
			$bkng_id=$this->input->post('bkng_id');
			$data_item=array();
			
			//delete old items
				$this->Booking_Model->delete_booking_assign_item($bkng_id,'extra_item');
				//echo $this->db->last_query();
			
			for($i=1; $i<=$rowCount_e; $i++){
			//	echo "/ $rowCount , Test:".$row[$i]['product_id'][0];
			
				if(isset($row[$i]['item_id'][0]))
				{					
				$data_item=array(
					'item_id'=>$row[$i]['item_id'][0],
					'bkng_id'=>$bkng_id,
					'bkng_itm_price'=>$row[$i]['price'][0],
					'bkng_itm_type'=>'',
					'bkng_extra_item'=>'Extra',
					'bkng_itm_qty'=>$row[$i]['itm_qty'][0], //need add
					'tot_amount'=>$row[$i]['sub_tot'][0], //need add
					'bkng_itm_added_date'=>date("Y-m-d H:i:s"),
					'user_id'=>$this->session->userdata('ss_user_id')
				);
				
				
				
				//add items
				$this->Booking_Model->save_menu_assign_item($data_item);
				//echo $this->db->last_query();
				
				}
				//save booking payment dtls
				$this->add_booking_dtls();
			}
			echo json_encode(array('error'=>$error,'disMsg'=>$disMsg,));
		
	}
	
	public function add_booking_dtls(){
		$error=false;
		$bkng_id=$this->input->post('bkng_id');
		$bkng_discount=$this->input->post('bkng_discount');
		$bkng_discount_value=$this->input->post('bkng_discount_value');
		$bkng_per_head_discount=$this->input->post('bkng_per_head_discount');
		$bkng_per_head_discount_value=$this->input->post('bkng_per_head_discount_value');
		$bkng_tot_amount=$this->input->post('bkng_tot_amount');
		$bkng_menu_amount=$this->input->post('bkng_menu_amount');
		$bkng_extra_menu_item_amount=$this->input->post('bkng_extra_menu_item_amount');
		$bkng_extra_item_amount=$this->input->post('bkng_extra_item_amount');
		$bkng_note=$this->input->post('bkng_note');
		$bkng_flora_bill_no=$this->input->post('bkng_flora_bill_no');
		$bkng_type=$this->input->post('bkng_type');
		$menu_amount_per_person_deduction=$this->input->post('menu_amount_per_person_deduction');
		$menu_items_sub_total=$this->input->post('menu_items_sub_total');
		
		$data_item=array();
		$data_item['bkng_discount_value']=$bkng_discount_value;
		$data_item['bkng_discount']=$bkng_discount; //added discount
		$data_item['bkng_per_head_discount']=$bkng_per_head_discount; // added per head discount
		$data_item['bkng_per_head_discount_value']=$bkng_per_head_discount_value; 
		$data_item['bkng_tot_amount']=$bkng_tot_amount;
		$data_item['bkng_menu_amount']=$bkng_menu_amount;
		$data_item['bkng_note']=$bkng_note;
		$data_item['bkng_type']=$bkng_type;
		$data_item['bkng_flora_bill_no']=$bkng_flora_bill_no;
		$data_item['menu_amount_per_person_deduction']=$menu_amount_per_person_deduction;
		$data_item['menu_items_sub_total']=$menu_items_sub_total;
			
		$this->Booking_Model->save_booking_header($data_item,$bkng_id);
		//echo $this->db->last_query();
	}
	
	

    public function booking_complete()
    {
		$this->add_booking_dtls();
		$bkng_id=$this->input->post('bkng_id');
		$error=false;
		if(!$error){
			echo json_encode(array('bkng_id'=>$bkng_id,'error'=>0,'msg'=>''));	
		}else{
			echo json_encode(array('bkng_id'=>$bkng_id,'error'=>1,'msg'=>"Please select these ($errtxt) before adding"));
		}
		
	}
	
	


    public function update_booking_header()
    {
		//echo 'test';
		
		//echo 'b id:'; print_r($this->input->post());
		$bkng_id=$this->input->post('bkng_id');
		$cus_id=$this->input->post('cus_id');
		$bkng_status=$this->input->post('bkng_status');
		$bkng_time=$this->input->post('bkng_time');
		$menu_id=$this->input->post('menu_id');
		$bkng_head_count=$this->input->post('bkng_head_count');
		$bkng_date=date('Y-m-d', strtotime($this->input->post('bkng_date')));
		$bkng_date_validate=date('Y-m-d', strtotime($this->input->post('bkng_date')));
		$warehouse_id=$this->input->post('warehouse_id');
		$bkng_type=$this->input->post('bkng_type');
		$bkng_menu_amount=$this->input->post('bkng_menu_amount');
		$bkng_discount_value=$this->input->post('bkng_discount_value'); // 23/10/2019 update
		
		$error=false;
		$errtxt='';
		if(!$bkng_date){
			//echo '111111111111111';
			$error=true;
			$errtxt.='Booking Date';
		}else if($this->Booking_Model->checkAvalabilityDate($bkng_id,$bkng_date_validate,$warehouse_id)){
			if($this->Booking_Model->checkAvalabilityTime($bkng_id,$bkng_date_validate,$bkng_time,$warehouse_id)){
				$error=true;
				$errtxt.='Selected Date, Time not avalable';
			}
		}
		if(!$cus_id){
			//echo '2222222222222';
			$error=true;
			if($errtxt) $errtxt.=', ';
			$errtxt.='Customer';
		}
		if(!$bkng_time){
			$error=true;
			if($errtxt) $errtxt.=', ';
			$errtxt.='Booking Time';
		}
		if(!$menu_id){
			$error=true;
			if($errtxt) $errtxt.=', ';
			$errtxt.='Menu';
		}
		if(!$bkng_head_count){
			$error=true;
			if($errtxt) $errtxt.=', ';
			$errtxt.='Head Count';
		}
		if(!$bkng_status){
			$error=true;
			if($errtxt) $errtxt.=', ';
			$errtxt.='Booking Status';
		}
		
		

		if(!$error){
			$data_item['bkng_id']=$bkng_id;
			$data_item['cus_id']=$cus_id;
			$data_item['bkng_status']=$bkng_status;
			$data_item['bkng_time']=$bkng_time;
			$data_item['bkng_date']=$bkng_date;
			$data_item['bkng_type']=$bkng_type;
			$data_item['menu_id']=$menu_id;
			$data_item['menu_items_sub_total']=0;
			
			$data_item['bkng_head_count']=$bkng_head_count;
			//get menu amount
			$menudetls=$this->Menu_Model->get_menu_info($menu_id);
			
			
			
			$menu_name_new=$menudetls['menu_name'];
			$data_item['bkng_tot_amount']=0;
			
			/* Check menu change, if change add new menu items and delete old items */
			//get old menu id
			$oldbookingdetails='';
			$oldbookingdetails=$this->Booking_Model->get_booking_details_by_id($bkng_id);
		//	print_r($oldbookingdetails);
			$menu_items_sub_total=$oldbookingdetails->menu_items_sub_total;
			
			$oldbookingmenuid=$oldbookingdetails->menu_id;
			$bkng_refno=$oldbookingdetails->bkng_refno;
			
		//	echo '<br/>menu_items_sub_total:'.$menu_items_sub_total;
			
			$oldbkng_head_count=$oldbookingdetails->bkng_head_count;
			
			
		//	if($menu_id!=$oldbookingmenuid || $oldbkng_head_count!=$bkng_head_count){
		if($menu_id!=$oldbookingmenuid){
				//echo "menu updated:".$menudetls['menu_price_'.$warehouse_id];
				
				//booking amount start
				
				$tmp='menu_price_'.$warehouse_id;
				if($bkng_head_count<50 && ($warehouse_id==3)){
					$tmp='menu_price_0_'.$warehouse_id;
				}else if($bkng_head_count<75){
					$tmp='menu_price_'.$warehouse_id;
				}else if($bkng_head_count<100){
					$tmp='menu_price_75_100_'.$warehouse_id;
				}
				else if($bkng_head_count<150){
					$tmp='menu_price_100_150_'.$warehouse_id;
				}else if($bkng_head_count>149){
					$tmp='menu_price_150_plus_'.$warehouse_id;
				}
				
				$bkng_menu_amount=$menudetls["$tmp"];

				if($bkng_menu_amount=='0.00') {
					$tmp='menu_price_'.$warehouse_id;
					$bkng_menu_amount=$menudetls["$tmp"];
				}
				
				//echo "<br/>tmp:".$tmp;
				//echo "<br/>bkng_menu_amount:".$bkng_menu_amount;
				
				//booking amount end
				
				
				$data_item['bkng_menu_amount']=$bkng_menu_amount;
				$data_item['bkng_tot_amount']=$bkng_menu_amount*$bkng_head_count;
				
				//delete old items
				$this->Booking_Model->delete_booking_assign_item($bkng_id);
				//send data to log table
				$menuolddetls=$this->Menu_Model->get_menu_info($oldbookingmenuid);
				$menu_name_old=$menuolddetls['menu_name'];
				
				$this->Common_Model->add_user_activitie("Booking ID: $bkng_refno , Menu Changed, From: $menu_name_old To: $menu_name_new");
			}else{
			    $data_item['bkng_tot_amount']=($bkng_menu_amount+$menu_items_sub_total)*$bkng_head_count;
			   $data_item['menu_items_sub_total']=$menu_items_sub_total;
			
			}
			
		//	print_r($menu_items_sub_total);
			
			
			//check per head count change
			$oldbkng_head_count=$oldbookingdetails->bkng_head_count;
			if($bkng_head_count!=$oldbkng_head_count){
			//	$data_item['bkng_per_head_discount']='0';
			//	$data_item['bkng_per_head_discount_value']='0';
			//	$data_item['bkng_per_head_discount']='0'; // 23/10/2019 update
			//	$data_item['bkng_per_head_discount_value']='0'; // 23/10/2019 update
				
				$per_head_dis_tot_amount=$data_item['bkng_per_head_discount']*$bkng_head_count; // 23/10/2019 update
				$data_item['bkng_per_head_discount_value']=$per_head_dis_tot_amount; // 23/10/2019 update
				$data_item['bkng_tot_amount']=$data_item['bkng_tot_amount']-$per_head_dis_tot_amount; // 23/10/2019 update
				
				//send data to log table
				$this->Common_Model->add_user_activitie("Booking ID: $bkng_refno , Head Count Changed, From: $oldbkng_head_count To: $bkng_head_count");
			}
			
			//check date changed
			$oldbkng_date=$oldbookingdetails->bkng_date;
			if($bkng_date!=$oldbkng_date){				
				//send data to log table
				$this->Common_Model->add_user_activitie("Booking ID: $bkng_refno , Booking Date Changed, From: $oldbkng_date To: $bkng_date");
			}
			
			//check time changed
			$oldbkng_time=$oldbookingdetails->bkng_time;
			if($bkng_time!=$oldbkng_time){				
				
				$this->Common_Model->add_user_activitie("Booking ID: $bkng_refno , Booking Time Changed, From: $oldbkng_time To: $bkng_time");
			}
			
			//check status changed
			$oldbkng_status=$oldbookingdetails->bkng_status;
			if($bkng_status!=$oldbkng_status){				
				//send data to log table
				$this->Common_Model->add_user_activitie("Booking ID: $bkng_refno , Booking Status Changed, From: $oldbkng_status To: $bkng_status");
			}
			
			//check status changed
			$oldcus_id=$oldbookingdetails->cus_id;
			if($cus_id!=$oldcus_id){				
				//send data to log table
				$this->Common_Model->add_user_activitie("Booking ID: $bkng_refno , Booking Customer Changed, From: $oldcus_id To: $cus_id");
			}
			
			// check manu id change, if changed delete all booking menu ids
			/* END Check menu change, if change add new menu items and delete old items */
			
			
			
			$this->Booking_Model->save_booking_header($data_item,$bkng_id);
				//echo $this->db->last_query();
				
		//	if($menu_id!=$oldbookingmenuid || $oldbkng_head_count!=$bkng_head_count){
			    if($menu_id!=$oldbookingmenuid){
				
			//add menu items to booking menu item table
			$selected_menu_list = $this->Menu_Model->get_selected_all_menu_items($menu_id);
			 if (isset($selected_menu_list)){
                  foreach ($selected_menu_list as $row)
                  {
						//insert menu items
						$arr=array();
						$arr['item_id']=$row->item_id;
						if($warehouse_id==1) {
							$arr['bkng_itm_price']=$row->item_price_1;
						}
						if($warehouse_id==2) {
							$arr['bkng_itm_price']=$row->item_price_2;
						}
						if($warehouse_id==3) {
							$arr['bkng_itm_price']=$row->item_price_1;
						}
						$arr['bkng_itm_type']='';
						$arr['bkng_id']=$bkng_id;
					 	$arr['bkng_itm_added_date']=date("Y-m-d H:i:s");
						$arr['user_id']=$this->session->userdata('ss_user_id');
						$this->Booking_Model->save_menu_assign_item($arr);			  
										  
				 }
			 }
			}
			
			//update booking summary details
			//$this->add_booking_dtls();
			
			
			//END add menu items to booking menu item table
			//echo $this->db->last_query();
			//$vcl_srvs_inv_id=$this->db->insert_id();
			
			echo json_encode(array('bkng_id'=>$bkng_id,'error'=>0,'msg'=>''));	
		}else{
			echo json_encode(array('bkng_id'=>$bkng_id,'error'=>1,'msg'=>"Please select these ($errtxt) before adding"));
		}
    }
		
	public function booking_header_save(){
		//insert header data
		$data_item=array();
		//print_r($this->input->post());
		$warehouse_id=$this->input->post('warehouse_id');
			$old_invoice_number=$this->input->post('old_invoice_number');
			$bkng_refno_new=$this->input->post('bkng_refno_new');
		$ref_id_nxt=$this->Booking_Model->gen_ref_number_booking('war_b_id','booking','','warehouse_id',$warehouse_id);
		//$vehicle_id=$this->input->post('vehicle_id');
		$cus_id=$this->input->post('cus_id');
		
		//$vcl_srvs_inv_no=$vehicle_id;
		$service_type=$this->input->post('service_type');
		$bkng_date=date('Y-m-d H:i:s', strtotime($this->input->post('bkng_date')));
		$bkng_date_validate=date('Y-m-d', strtotime($this->input->post('bkng_date')));
		$bkng_status=$this->input->post('bkng_status');
		$bkng_time=$this->input->post('bkng_time');
		$bkng_type=$this->input->post('bkng_type');
		$menu_id=$this->input->post('menu_id');
		$bkng_head_count=$this->input->post('bkng_head_count');
		
		
		//get warehouse code
		$warehouse_dtls=$this->Warehouse_Model->get_warehouse_info($warehouse_id);
		
		$warehouse_code=$warehouse_dtls['code'];
		if(!$bkng_refno_new){
		$bkng_refno=$warehouse_code.$ref_id_nxt;
		}else{
		$bkng_refno=$bkng_refno_new;	
		}
		
		//$bkng_refno=$warehouse_code.$ref_id_nxt;
		
		$error=false;
		$errtxt='';
		
		
		
		if(!$bkng_date){
			//echo '111111111111111';
			$error=true;
			$errtxt.='Booking Date';
		}else if($this->Booking_Model->checkAvalabilityDate('',$bkng_date_validate,$warehouse_id)){
			if($this->Booking_Model->checkAvalabilityTime('',$bkng_date_validate,$bkng_time,$warehouse_id)){
				$error=true;
				$errtxt.='Selected Date, Time not avalable';
			}
		}
		if(!$cus_id){
			//echo '2222222222222';
			$error=true;
			if($errtxt) $errtxt.=', ';
			$errtxt.='Customer';
		}
		if(!$bkng_time){
			$error=true;
			if($errtxt) $errtxt.=', ';
			$errtxt.='Booking Time';
		}
		if(!$menu_id){
			$error=true;
			if($errtxt) $errtxt.=', ';
			$errtxt.='Menu';
		}
		if(!$bkng_head_count){
			$error=true;
			if($errtxt) $errtxt.=', ';
			$errtxt.='Head Count';
		}
		if(!$bkng_status){
			$error=true;
			if($errtxt) $errtxt.=', ';
			$errtxt.='Booking Status';
		}
		if(!$warehouse_id){
			$error=true;
			if($errtxt) $errtxt.=', ';
			$errtxt.='Warehouse';
		}
		//check booking avalability
		
		
		if(!$error){
			//$data_item['bkng_id']=$bkng_id;
			$data_item['bkng_refno']=$bkng_refno;
			$data_item['warehouse_id']=$warehouse_id;
			$data_item['cus_id']=$cus_id;
			$data_item['war_b_id']=$ref_id_nxt;
			$data_item['bkng_status']=$bkng_status;
			$data_item['bkng_time']=$bkng_time;
			$data_item['bkng_type']=$bkng_type;
			$data_item['bkng_date']=$bkng_date;
			$data_item['bkng_user_id']=$this->session->userdata('ss_user_id');
			$data_item['bkng_added_date']=date('Y-m-d H:i:s');
			$data_item['menu_id']=$menu_id;
			//get menu amount
			$menudetls=$this->Menu_Model->get_menu_info($menu_id);
			
			if($warehouse_id==2){
				$data_item['bkng_menu_amount']=$menudetls['menu_price_'.$warehouse_id];
				$bkng_menu_amount=$menudetls['menu_price_'.$warehouse_id];
			}else{
				$data_item['bkng_menu_amount']=$menudetls['menu_price_1'];
				$bkng_menu_amount=$menudetls['menu_price_1'];
			}
			
			
			
				$tmp='menu_price_'.$warehouse_id;
				if($bkng_head_count<50 && ($warehouse_id==3)){
					$tmp='menu_price_0_'.$warehouse_id;
				}else if($bkng_head_count<75){
					$tmp='menu_price_'.$warehouse_id;
				}else if($bkng_head_count<100){
					$tmp='menu_price_75_100_'.$warehouse_id;
				}
				else if($bkng_head_count<150){
					$tmp='menu_price_100_150_'.$warehouse_id;
				}else if($bkng_head_count>149){
					$tmp='menu_price_150_plus_'.$warehouse_id;
				}
				
				//echo "Test:".$tmp;
				//print_r($menudetls);
				//echo "<br/>price:".$menudetls["$tmp"];
				//die();
				
				$bkng_menu_amount=$menudetls["$tmp"];
				$data_item['bkng_menu_amount']=$menudetls["$tmp"];
				

			
			$data_item['bkng_tot_amount']=$bkng_menu_amount*$bkng_head_count;
			$data_item['bkng_head_count']=$bkng_head_count;
			
			$data_item['bkng_reg_date']=date("Y-m-d H:i:s");
			$data_item['old_invoice_number']=$old_invoice_number;

			
			$this->Booking_Model->save_booking_header($data_item);
			$bkng_id=$this->db->insert_id();
			
			//add menu items to booking menu item table
			$selected_menu_list = $this->Menu_Model->get_selected_all_menu_items($menu_id);
			 if (isset($selected_menu_list)){
                  foreach ($selected_menu_list as $row)
                  {
						//insert menu items
						$arr=array();
						$arr['item_id']=$row->item_id;
						if($warehouse_id==1) {
							$arr['bkng_itm_price']=$row->item_price_1;
						}
						if($warehouse_id==2) {
							$arr['bkng_itm_price']=$row->item_price_2;
						}
						if($warehouse_id==3) {
							$arr['bkng_itm_price']=$row->item_price_1;
						}
						
						
						$arr['bkng_itm_type']='';
						$arr['bkng_id']=$bkng_id;
					 	$arr['bkng_itm_added_date']=date("Y-m-d H:i:s");
						$arr['user_id']=$this->session->userdata('ss_user_id');
						$this->Booking_Model->save_menu_assign_item($arr);			  
										  
				 }
			 }
			//END add menu items to booking menu item table
			
			
			
			//echo $this->db->last_query();
			//$vcl_srvs_inv_id=$this->db->insert_id();
			
			echo json_encode(array('bkng_id'=>$bkng_id,'error'=>0,'msg'=>''));	
		}else{
			echo json_encode(array('bkng_id'=>'','error'=>1,'msg'=>"Please select these ($errtxt) before adding"));
		}
		
	}
	
public function get_list_booking($value='')
	{
		
		$wareh_id= $this->input->post('warehouse_id');
		//$wareh_id='';
		if($this->session->userdata('ss_group_id')==2){
			
		}else {
			//$wareh_id=$this->session->userdata('ss_warehouse_id');
		}
	        $values = $this->Booking_Model->getBookings($wareh_id);
			$columns = array( 
		0 =>'bkng_id', 
		1 => 'bkng_id',
		2=> 'bkng_id',
		3 =>'bkng_id', 
		4 => 'bkng_id',
		5=> 'bkng_id',
		6=> 'bkng_id',
		7=> 'bkng_id',
		8=> 'bkng_id'
	);
	        $data = array();
			//print_r($values);

	        if (!empty($values)) {
	            foreach ($values as $users) {
					
	            $row = array();
					$bkng_id=$users->bkng_id;
					$row[] = $users->bkng_id;
				
	                $row[] = $users->bkng_refno;
	                	$row[] = $users->name;
					$row[] = $users->bkng_reg_date;
	                $row[] = $users->cus_name;
					$row[] = $users->menu_name;	
						$row[] = $users->bkng_menu_amount;	
	                $row[] = $users->bkng_date;
					$time_cls='';
					if($users->bkng_time=='Morning'){
							$clas="label-success";
						}if($users->bkng_time=='Evening'){
							$clas="label-purple";
						}
	               $row[] = "<span class='label $clas'>".$users->bkng_time."</span>";
				   
					   $clas='';
					   /*
					   	if($users->bkng_status=='Confirmed'){
							$clas="label-success";
						}if($users->bkng_status=='Requested'){
							$clas="label-warning";
						}
						if($users->bkng_status=='Removed'){
							$clas="label-inverse";
						}*/
					    // $row[] = "<span class='label $clas'>".$users->bkng_status."</span>";
						 $row[] = $users->bkng_status;
						 
						 
					
					$booking_editable=false;
					
					$booking_editable=is_booking_editable($users->bkng_date);
					
						$booking_editable=false;// for add old items
					
					$total_paid_amount=0;	
					$total_paid_amount=$this->Booking_Model->get_total_paid_by_booking_id($bkng_id);
					
					 
					 
					 $row[]=$users->bkng_head_count;	
					 $pay_st='';
					 if (empty($total_paid_amount)) {
						 
						  
						  if($total_paid_amount<$users->bkng_tot_amount){
								if(is_due_date($users->bkng_date)){
									$pay_st = '<span class="label label-danger">Due: Pending</span>';
								}else {
								$pay_st = '<span class="label label-info">Pending</span>';
							    }
						  }
						}
						else{
						  if ($total_paid_amount >= $users->bkng_tot_amount) {
							$pay_st = '<span class="label label-success">Paid</span>';
						  }else{
							  
							if($total_paid_amount<$users->bkng_tot_amount){
								if(is_due_date($users->bkng_date)){
									$pay_st = '<span class="label label-danger">Due: Partial</span>';
								}else {
								$pay_st = '<span class="label label-info">Partial</span>';
							    }
						  }
						}
						}
					 	$row[] = $pay_st;
					 
					  $row[] = number_format($users->bkng_tot_amount, 2, '.', ',');	
					  $row[]=number_format($total_paid_amount, 2, '.', ',');	
					   $row[] =number_format($users->bkng_tot_amount-$total_paid_amount, 2, '.', ',');
						

						
																				
				$row_action = '<div class="btn-group text-left">
                            <button data-toggle="dropdown" class="btn btn-default btn-xs btn-primary dropdown-toggle" type="button">Actions <span class="caret"></span></button>
                            <ul role="menu" class="dropdown-menu pull-right">';
							
							if($users->bkng_id==1){
								 $row_action.=' <li><a style="cursor: pointer;" onClick="disableUserData('.$users->bkng_id.')"><i class="fa fa-check"></i> Disable User</a></li>';
							}
							
							if($users->bkng_id==0){
								 $row_action.=' <li><a style="cursor: pointer;" onClick="enableUserData('.$users->bkng_id.')"><i class="glyphicon fa fa-minus-circle"></i> Enable User</a></li>';
							}
							
						if ($this->session->userdata('ss_group_id')!=4) {	
						if(!$booking_editable){	
                         $row_action.= '                           
							 <li><a href="'.base_url().'booking/manage/'.$users->bkng_id.'"><i class="fa fa-trash-o"></i> Update Booking Details</a></li>';
						}
						}
							 $row_action.= ' <li><a href="'.base_url().'booking/details/'.$users->bkng_id.'"><i class="fa fa-trash-o"></i> Booking Details</a></li>
							<li><a onClick="fbs_click('.$users->bkng_id.')" data-toggle="modal" href="#" data-placement="top" data-original-title="Edit suppliers"><i class="fa fa-print"></i> Print Booking Invoice</a></li>
						
                            </ul></div>';
							
							$row[]=$row_action;
				
				//$row[]=$actionTxtUpdate.$actionTxtDisble.$actionTxtEnable.$actionTxtPw.$actionTxtDelete;
	
	                $data[] = $row;
	            }


	            $output = array('data' =>$data);
	            echo json_encode($output);
	        }else{
	            $output = array('data' =>'');
	            echo json_encode($output);

	        }
	   }
	
	
	

}