<?php
class Booking_Model extends CI_Model {
	 private $tableName = 'user';
  
  
  function __construct() 
  {
   		/* Call the Model constructor */
    	parent::__construct();
        $this->load->database();
        $this->load->helper('url');
        $this->load->library(array('email'));
  }
 

   
	public function delete_booking_assign_item($bkng_id,$type='')
	{
		$this->db->where('bkng_id', $bkng_id);
		if($type=='extra_item'){
			$this->db->where('bkng_extra_item', 'Extra');
		}else {
			$this->db->where('bkng_extra_item', '');
		}
		$this->db->delete('booking_menu_items');
	
	}
  
  	//get service suggestions
	function get_menu_items_suggestions($term) {
		$this->db->select('menu_item'.'.*');
		
		
		$this->db->order_by("item_name", "asc");
		$this->db->where("item_extra",'');
		$this->db->where("(item_name LIKE '%$term%' OR item_code LIKE '%$term%') ");
		 $this->db->limit(10, 0);
		$query = $this->db->get('menu_item');
		//echo $this->db->last_query();
		return $query->result_array();
	}

	function get_menu_extra_items_suggestions($term) {
		$this->db->select('menu_item.*');
		$this->db->order_by("item_name", "asc");
		$this->db->where("item_extra",'Extra');
		$this->db->where("(item_name LIKE '%$term%' OR item_code LIKE '%$term%') ");
		 $this->db->limit(10, 0);
		$query = $this->db->get('menu_item');
		//echo $this->db->last_query();
		return $query->result_array();
	}
	
		
	
	function save_menu_assign_item($arr,$id=false)
	{
		if (!$id)
		{
			$this->db->insert('booking_menu_items',$arr);
		}
	}
 
 	function get_booking_detais_and_selected_all_menu_items($bkng_id) {
		$this->db->select('w.*,b.*,bi.*,i.*,c.*');
		$this->db->from('booking_menu_items bi');
		$this->db->join('menu_item i', 'i.item_id = bi.item_id', 'left');
		$this->db->join('booking b', 'b.bkng_id = bi.bkng_id', 'left');
		$this->db->join('warehouses w', 'w.id = b.warehouse_id', 'left');
		$this->db->join('customer c', 'c.cus_id = b.cus_id', 'left');
		//$this->db->join('user u', 'u.user_id = b.bkng_user_id', 'left');
		//$this->db->join('menu m', 'm.menu_id = bi.menu_id', 'left');
		$this->db->order_by("i.menu_id", "asc");
		$this->db->where("bi.bkng_id",$bkng_id);//("id !=",$id);
		$query = $this->db->get();
		//echo $this->db->last_query();
		return $query->result();
	}
	 
	function get_booking_selected_all_menu_items($bkng_id,$val='',$extra_item='') {
		$this->db->select('bi.*,i.*');
		$this->db->from('booking_menu_items bi');
		$this->db->join('menu_item i', 'i.item_id = bi.item_id', 'left');
		//$this->db->join('menu m', 'm.menu_id = bi.menu_id', 'left');
		$this->db->order_by("bi.bk_itm_id", "asc");
		if($extra_item=='extra_item'){
			$this->db->where("bi.bkng_extra_item",'Extra');//("id !=",$id);
		}else {
		
			//$this->db->where("bi.bkng_itm_type",'');//("id !=",$id);
			$this->db->where("bi.bkng_extra_item",'');
		}
		
		$this->db->where("bi.bkng_id",$bkng_id);//("id !=",$id);
		$query = $this->db->get();
		//echo $this->db->last_query();
		return $query->result();
	}
	
	//Sales save
	function save_booking_header(&$arr,$id=false)
	{
		if (!$id)
		{
			$this->db->insert('booking',$arr);
		}else {
			$this->db->where('bkng_id', $id);
			return $this->db->update('booking',$arr);
		}
	}
	
	
   function checkAvalabilityDate($bkng_id='',$bkng_date='',$warehouse_id='')
   {
	   $this->db->select('b.bkng_id');
       $this->db->from('booking b');
	   
	   $error=false;
	   $this->db->where("b.bkng_status",'Confirmed');
	    if($bkng_id){
	   	   $this->db->where("b.bkng_id !=",$bkng_id);//
	   }
	   if($warehouse_id){
	   	   $this->db->where("b.warehouse_id",$warehouse_id);//
	   }
	   if($bkng_date){
	   		$this->db->where("b.bkng_date",$bkng_date);//
	   }	   
	   $this->db->order_by("b.bkng_time", "desc");
	   
	   $query = $this->db->get();
	   //echo $this->db->last_query();
     if($query->num_rows() >0)
     {
        return true;
     }
     else
     {
       return false;
     }

   }	

   function checkAvalabilityTime($bkng_id='',$bkng_date='',$bkng_time='',$warehouse_id='')
   {
	   $this->db->select('b.*');
       $this->db->from('booking b');
	   
	   $error=false;
	   $this->db->where("b.bkng_status",'Confirmed');//
	   
	   if($bkng_id){
	   	   $this->db->where("b.bkng_id !=",$bkng_id);//
	   }
	   if($warehouse_id){
	   	   $this->db->where("b.warehouse_id",$warehouse_id);//
	   }
	   if($bkng_date){
	   		$this->db->where("b.bkng_date",$bkng_date);//
	   }
	    if($bkng_time){
	   		$this->db->where("b.bkng_time",$bkng_time);//
	   }	   
	   $this->db->order_by("b.bkng_time", "desc");
	   //
	   $query = $this->db->get();
	   //echo $this->db->last_query();
     if($query->num_rows() >0)
     {
       return true;
     }
     else
     {
       return false;
     }

   }
   
 
  function getPaymentsForPrint($srh_warehouse_id='',$srh_to_date='',$srh_from_date='')
   {
	   $this->db->select('p.*,c.cus_name,b.*,u.user_first_name');
       $this->db->from('booking_payment p');
	   $this->db->join('booking b', 'b.bkng_id = p.bkng_id', 'left');
	   $this->db->join('warehouses w', 'w.id = b.warehouse_id', 'left');
	   $this->db->join('customer c', 'c.cus_id = b.cus_id', 'left');
	    $this->db->join('user u', 'u.user_id = p.user_id', 'left');
	
		
	   if($srh_warehouse_id){
	   
	   $this->db->where("b.warehouse_id",$srh_warehouse_id);//
	   }
	   if($srh_to_date){
			$this->db->where("p.pymnt_date_time <=",$srh_to_date);//("id !=",$id);
		}
		if($srh_from_date){
			$this->db->where("p.pymnt_date_time >=",$srh_from_date);//("id !=",$id);
		}
	   $this->db->order_by("b.bkng_id", "desc");
	  
	   $query = $this->db->get();
	   // echo $this->db->last_query();
     if($query->num_rows() >0)
     {
       return $query->result();
     }
     else
     {
       //return false;
     }

   }
   
     
 function getBookingsForPrint($srh_warehouse_id='',$srh_to_date='',$srh_from_date='')
   {
	   $this->db->select('b.*,c.cus_name,u.user_first_name');
       $this->db->from('booking b');
	   $this->db->join('warehouses w', 'w.id = b.warehouse_id', 'left');
	   $this->db->join('customer c', 'c.cus_id = b.cus_id', 'left');
	   $this->db->join('user u', 'u.user_id = b.bkng_user_id', 'left');
		
	   if($srh_warehouse_id){
	   
	   $this->db->where("b.warehouse_id",$srh_warehouse_id);//
	   }
	   if($srh_to_date){
			$this->db->where("b.bkng_date <=",$srh_to_date);//("id !=",$id);
		}
		if($srh_from_date){
			$this->db->where("b.bkng_date >=",$srh_from_date);//("id !=",$id);
		}
	   $this->db->order_by("b.bkng_id", "desc");
	  
	   $query = $this->db->get();
	   // echo $this->db->last_query();
     if($query->num_rows() >0)
     {
       return $query->result();
     }
     else
     {
       //return false;
     }

   }

 function getSalesForPrint($srh_warehouse_id='',$srh_to_date='',$srh_from_date='')
   {
	   $this->db->select('b.*,c.cus_name,u.user_first_name');
       $this->db->from('booking b');
	   $this->db->join('warehouses w', 'w.id = b.warehouse_id', 'left');
	   $this->db->join('customer c', 'c.cus_id = b.cus_id', 'left');
	   $this->db->join('user u', 'u.user_id = b.bkng_user_id', 'left');
		
	   if($srh_warehouse_id){
	   
	   $this->db->where("b.warehouse_id",$srh_warehouse_id);//
	   }
	   if($srh_to_date){
			$this->db->where("b.bkng_reg_date <=",$srh_to_date);//("id !=",$id);
		}
		if($srh_from_date){
			$this->db->where("b.bkng_reg_date >=",$srh_from_date);//("id !=",$id);
		}
	   $this->db->order_by("b.bkng_id", "desc");
	  
	   $query = $this->db->get();
	   // echo $this->db->last_query();
     if($query->num_rows() >0)
     {
       return $query->result();
     }
     else
     {
       //return false;
     }

   }
        
   function getBookings($warehouse_id='')
   {
	   $this->db->select('b.*,c.cus_name,m.menu_name');
       $this->db->from('booking b');
	   $this->db->join('warehouses w', 'w.id = b.warehouse_id', 'left');
	   $this->db->join('customer c', 'c.cus_id = b.cus_id', 'left');
	   $this->db->join('menu m', 'm.menu_id = b.menu_id', 'left');
	   //$this->db->where("b.bkng_status",'Confirmed');//
	   if($warehouse_id){
	   
	   $this->db->where("b.warehouse_id",$warehouse_id);//
	   }
	   $this->db->order_by("b.bkng_time", "desc");
	 //  
	   $query = $this->db->get();
	  // echo $this->db->last_query();
     if($query->num_rows() >0)
     {
       return $query->result();
     }
     else
     {
       //return false;
     }

   }
   
      function getBookingsCal($warehouse_id='')
   {
	   $this->db->select('b.*,c.cus_name,m.menu_name');
       $this->db->from('booking b');
	   $this->db->join('warehouses w', 'w.id = b.warehouse_id', 'left');
	   $this->db->join('customer c', 'c.cus_id = b.cus_id', 'left');
	   $this->db->join('menu m', 'm.menu_id = b.menu_id', 'left');
	   $this->db->where("b.bkng_status",'Confirmed');//
	   if($warehouse_id){
	   
	   $this->db->where("b.warehouse_id",$warehouse_id);//
	   }
	   $this->db->order_by("b.bkng_time", "desc");
	 //  
	   $query = $this->db->get();
	  // echo $this->db->last_query();
     if($query->num_rows() >0)
     {
       return $query->result();
     }
     else
     {
       //return false;
     }

   }
   	
/*   function getBookings()
   {
	   $this->db->select('b.*,c.cus_name');
       $this->db->from('booking b');
	   $this->db->join('customer c', 'c.cus_id = b.cus_id', 'left');
	   $this->db->order_by("b.bkng_id", "desc");
	   $query = $this->db->get();
	   
     if($query->num_rows() >0)
     {
       return $query->result();
     }
     else
     {
       return false;
     }

   }*/
   
   	function get_booking_payments_by_booking_id($bkng_id) {
		$this->db->select('bp.*,u.user_first_name,up.user_group_name');
		$this->db->from('booking_payment bp');
		$this->db->join('user u', 'bp.user_id = u.user_id', 'left');
		$this->db->join('user_group up', 'u.group_id = up.user_group_id', 'left');
		$this->db->order_by("bp.paymnt_id", "asc");
		$this->db->where("bp.bkng_id",$bkng_id);//("id !=",$id);
		$query = $this->db->get();
		return $query->result();
	}
   
  //Sales get toatal paid 
  function get_total_paid_by_booking_id($bkng_id){
	$this->db->select_sum('bp.pymnt_amount');
	$this->db->from('booking_payment bp');
	$this->db->where('bp.bkng_id',$bkng_id);
	$query=$this->db->get();
	if($query->row()-> pymnt_amount){
		return $query->row()-> pymnt_amount;
	}else {
		return 0;
	}
  }
  
	function save_booking_payments(&$data,$id=false)
	{
		if (!$id)
		{
			return $this->db->insert('booking_payment',$data);
		}else{
			return false;	
		}
	}
	
	function change_collected_status(&$data,$id=false)
	{
		if (!$id)
		{
			return $this->db->insert('booking_payment',$data);
		}else{
			$this->db->where('paymnt_id', $id);
			return $this->db->update('booking_payment',$data);
		}
	}
	
	//get booking details by id
   function get_booking_details_by_id($bkng_id='')
   {
     $this->db->select('b.*, u.user_first_name,m.*,c.cus_name');
	 //$this->db->select('b.warehouse_id');
	 
     $this->db->from('booking b');
	 $this->db->join('user u', 'u.user_id = b.bkng_user_id', 'left');
	 $this->db->join('menu m', 'm.menu_id = b.menu_id', 'left');
	 $this->db->join('customer c', 'c.cus_id = b.cus_id', 'left');
     $this->db->where('b.bkng_id',$bkng_id);
     $query = $this->db->get(); 
	// echo $this->db->last_query(); 
     if($query->num_rows() >0)
     {
       return $query->row();
     }
     else
     {
       return false;
     }
   }
   
      public function gen_ref_number_booking($column_name,$table_name,$type_code,$whecol='',$wheval='')
   {
	   
	$this->db->select_max($table_name.'.war_b_id');
	if($whecol){
	$this->db->where($whecol, $wheval);
	}
	$query = $this->db->get($table_name);
     if($query->num_rows() >0)
     {
       $g = $query->result();
       $u = $this->set_ref_no($g[0]->$column_name,$type_code);
       return $u;
     }
     else
     {
       return false;
     }
   }

   function set_ref_no($f,$t)
   {
	  $w='';
   	 $d = date('Y/m/');
	 if($t){
		$w=$t;
	 }
   	 $w =$w.sprintf("%03d",$f+1);
   	 return $w;
   }
}